/**
 *                                                                            
 *  Copyright (c) 2011, 2016 - Loetz GmbH&Co.KG (69115 Heidelberg, Germany) 
 *                                                                            
 *  All rights reserved. This program and the accompanying materials           
 *  are made available under the terms of the Eclipse Public License 2.0        
 *  which accompanies this distribution, and is available at                  
 *  https://www.eclipse.org/legal/epl-2.0/                                 
 *                                 
 *  SPDX-License-Identifier: EPL-2.0                                 
 *                                                                            
 *  Contributors:                                                      
 * 	   Christophe Loetz (Loetz GmbH&Co.KG) - initial implementation
 * 
 */
 package org.eclipse.osbp.ecview.core.extension.model.datatypes.provider;

import java.util.ArrayList;
import java.util.Collection;

import java.util.List;
import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.edit.command.CommandParameter;
import org.eclipse.emf.edit.domain.EditingDomain;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ChildCreationExtenderManager;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IChildCreationExtender;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import org.eclipse.osbp.ecview.core.common.model.core.CoreModelPackage;
import org.eclipse.osbp.ecview.core.common.model.core.YEmbeddable;
import org.eclipse.osbp.ecview.core.common.model.core.util.CoreModelSwitch;
import org.eclipse.osbp.ecview.core.extension.model.datatypes.ExtDatatypesFactory;
import org.eclipse.osbp.ecview.core.extension.model.datatypes.ExtDatatypesPackage;
import org.eclipse.osbp.ecview.core.extension.model.datatypes.util.ExtDatatypesAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class ExtDatatypesItemProviderAdapterFactory extends ExtDatatypesAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable, IChildCreationExtender {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This helps manage the child creation extenders.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ChildCreationExtenderManager childCreationExtenderManager = new ChildCreationExtenderManager(ExtensionEditPlugin.INSTANCE, ExtDatatypesPackage.eNS_URI);

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExtDatatypesItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTextDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YTextDatatypeItemProvider yTextDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTextDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYTextDatatypeAdapter() {
		if (yTextDatatypeItemProvider == null) {
			yTextDatatypeItemProvider = new YTextDatatypeItemProvider(this);
		}

		return yTextDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTextAreaDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YTextAreaDatatypeItemProvider yTextAreaDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTextAreaDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYTextAreaDatatypeAdapter() {
		if (yTextAreaDatatypeItemProvider == null) {
			yTextAreaDatatypeItemProvider = new YTextAreaDatatypeItemProvider(this);
		}

		return yTextAreaDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YNumericDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YNumericDatatypeItemProvider yNumericDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YNumericDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYNumericDatatypeAdapter() {
		if (yNumericDatatypeItemProvider == null) {
			yNumericDatatypeItemProvider = new YNumericDatatypeItemProvider(this);
		}

		return yNumericDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YDecimalDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDecimalDatatypeItemProvider yDecimalDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YDecimalDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDecimalDatatypeAdapter() {
		if (yDecimalDatatypeItemProvider == null) {
			yDecimalDatatypeItemProvider = new YDecimalDatatypeItemProvider(this);
		}

		return yDecimalDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTableDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YTableDatatypeItemProvider yTableDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTableDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYTableDatatypeAdapter() {
		if (yTableDatatypeItemProvider == null) {
			yTableDatatypeItemProvider = new YTableDatatypeItemProvider(this);
		}

		return yTableDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YCheckBoxDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YCheckBoxDatatypeItemProvider yCheckBoxDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YCheckBoxDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYCheckBoxDatatypeAdapter() {
		if (yCheckBoxDatatypeItemProvider == null) {
			yCheckBoxDatatypeItemProvider = new YCheckBoxDatatypeItemProvider(this);
		}

		return yCheckBoxDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YComboBoxDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YComboBoxDatatypeItemProvider yComboBoxDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YComboBoxDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYComboBoxDatatypeAdapter() {
		if (yComboBoxDatatypeItemProvider == null) {
			yComboBoxDatatypeItemProvider = new YComboBoxDatatypeItemProvider(this);
		}

		return yComboBoxDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YListDataType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YListDataTypeItemProvider yListDataTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YListDataType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYListDataTypeAdapter() {
		if (yListDataTypeItemProvider == null) {
			yListDataTypeItemProvider = new YListDataTypeItemProvider(this);
		}

		return yListDataTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YOptionsGroupDataType} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YOptionsGroupDataTypeItemProvider yOptionsGroupDataTypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YOptionsGroupDataType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYOptionsGroupDataTypeAdapter() {
		if (yOptionsGroupDataTypeItemProvider == null) {
			yOptionsGroupDataTypeItemProvider = new YOptionsGroupDataTypeItemProvider(this);
		}

		return yOptionsGroupDataTypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YBrowserDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YBrowserDatatypeItemProvider yBrowserDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YBrowserDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYBrowserDatatypeAdapter() {
		if (yBrowserDatatypeItemProvider == null) {
			yBrowserDatatypeItemProvider = new YBrowserDatatypeItemProvider(this);
		}

		return yBrowserDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YDateTimeDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YDateTimeDatatypeItemProvider yDateTimeDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YDateTimeDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYDateTimeDatatypeAdapter() {
		if (yDateTimeDatatypeItemProvider == null) {
			yDateTimeDatatypeItemProvider = new YDateTimeDatatypeItemProvider(this);
		}

		return yDateTimeDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTreeDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YTreeDatatypeItemProvider yTreeDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTreeDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYTreeDatatypeAdapter() {
		if (yTreeDatatypeItemProvider == null) {
			yTreeDatatypeItemProvider = new YTreeDatatypeItemProvider(this);
		}

		return yTreeDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YProgressBarDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YProgressBarDatatypeItemProvider yProgressBarDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YProgressBarDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYProgressBarDatatypeAdapter() {
		if (yProgressBarDatatypeItemProvider == null) {
			yProgressBarDatatypeItemProvider = new YProgressBarDatatypeItemProvider(this);
		}

		return yProgressBarDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTabSheetDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YTabSheetDatatypeItemProvider yTabSheetDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YTabSheetDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYTabSheetDatatypeAdapter() {
		if (yTabSheetDatatypeItemProvider == null) {
			yTabSheetDatatypeItemProvider = new YTabSheetDatatypeItemProvider(this);
		}

		return yTabSheetDatatypeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YMasterDetailDatatype} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected YMasterDetailDatatypeItemProvider yMasterDetailDatatypeItemProvider;

	/**
	 * This creates an adapter for a {@link org.eclipse.osbp.ecview.core.extension.model.datatypes.YMasterDetailDatatype}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createYMasterDetailDatatypeAdapter() {
		if (yMasterDetailDatatypeItemProvider == null) {
			yMasterDetailDatatypeItemProvider = new YMasterDetailDatatypeItemProvider(this);
		}

		return yMasterDetailDatatypeItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public List<IChildCreationExtender> getChildCreationExtenders() {
		return childCreationExtenderManager.getChildCreationExtenders();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Collection<?> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
		return childCreationExtenderManager.getNewChildDescriptors(object, editingDomain);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ResourceLocator getResourceLocator() {
		return childCreationExtenderManager;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (yTextDatatypeItemProvider != null) yTextDatatypeItemProvider.dispose();
		if (yTextAreaDatatypeItemProvider != null) yTextAreaDatatypeItemProvider.dispose();
		if (yNumericDatatypeItemProvider != null) yNumericDatatypeItemProvider.dispose();
		if (yDecimalDatatypeItemProvider != null) yDecimalDatatypeItemProvider.dispose();
		if (yTableDatatypeItemProvider != null) yTableDatatypeItemProvider.dispose();
		if (yCheckBoxDatatypeItemProvider != null) yCheckBoxDatatypeItemProvider.dispose();
		if (yComboBoxDatatypeItemProvider != null) yComboBoxDatatypeItemProvider.dispose();
		if (yListDataTypeItemProvider != null) yListDataTypeItemProvider.dispose();
		if (yOptionsGroupDataTypeItemProvider != null) yOptionsGroupDataTypeItemProvider.dispose();
		if (yBrowserDatatypeItemProvider != null) yBrowserDatatypeItemProvider.dispose();
		if (yDateTimeDatatypeItemProvider != null) yDateTimeDatatypeItemProvider.dispose();
		if (yTreeDatatypeItemProvider != null) yTreeDatatypeItemProvider.dispose();
		if (yProgressBarDatatypeItemProvider != null) yProgressBarDatatypeItemProvider.dispose();
		if (yTabSheetDatatypeItemProvider != null) yTabSheetDatatypeItemProvider.dispose();
		if (yMasterDetailDatatypeItemProvider != null) yMasterDetailDatatypeItemProvider.dispose();
	}

	/**
	 * A child creation extender for the {@link CoreModelPackage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static class CoreModelChildCreationExtender implements IChildCreationExtender {
		/**
		 * The switch for creating child descriptors specific to each extended class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		protected static class CreationSwitch extends CoreModelSwitch<Object> {
			/**
			 * The child descriptors being populated.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected List<Object> newChildDescriptors;

			/**
			 * The domain in which to create the children.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected EditingDomain editingDomain;

			/**
			 * Creates the a switch for populating child descriptors in the given domain.
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			CreationSwitch(List<Object> newChildDescriptors, EditingDomain editingDomain) {
				this.newChildDescriptors = newChildDescriptors;
				this.editingDomain = editingDomain;
			}
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			@Override
			public Object caseYEmbeddable(YEmbeddable object) {
				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYTextDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYTextAreaDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYNumericDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYDecimalDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYTableDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYCheckBoxDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYComboBoxDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYListDataType()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYOptionsGroupDataType()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYBrowserDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYDateTimeDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYTreeDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYProgressBarDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYTabSheetDatatype()));

				newChildDescriptors.add
					(createChildParameter
						(CoreModelPackage.Literals.YEMBEDDABLE__ORPHAN_DATATYPES,
						 ExtDatatypesFactory.eINSTANCE.createYMasterDetailDatatype()));

				return null;
			}
 
			/**
			 * <!-- begin-user-doc -->
			 * <!-- end-user-doc -->
			 * @generated
			 */
			protected CommandParameter createChildParameter(Object feature, Object child) {
				return new CommandParameter(null, feature, child);
			}

		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public Collection<Object> getNewChildDescriptors(Object object, EditingDomain editingDomain) {
			ArrayList<Object> result = new ArrayList<Object>();
			new CreationSwitch(result, editingDomain).doSwitch((EObject)object);
			return result;
		}

		/**
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		public ResourceLocator getResourceLocator() {
			return ExtensionEditPlugin.INSTANCE;
		}
	}

}
